<template>
  <ob-modal
    ref="expertTarif"
    title="Экспертный тариф"
    size="medium"
    custom-class="modal-medium"
    :is-show-pagination="false"
    :is-show-controls="true"
    :okText="confirmText"
    :is-submit-disabled="submitDisabled"
    @submit="saveExpert"
    @closed="$emit('closed')"
  >
    <expert-modal-content
      :data="data"
      :rateData="rateData"
      :introduced="introduced"
      @expertChanged="updateStagePrice"
    />
  </ob-modal>
</template>
<script>
import api from '@/api';
import ObModal from 'common-components/src/obComponents/obModal';
import ExpertModalContent from './ExpertRateModal';

const PRICE_TYPE = {
  EMPTY: 'EMPTY',
  EXPERT: 'EXPERT',
  EXTRAPOLATED: 'EXTRAPOLATED',
};

export default {
  name: 'ExpertRateModal',
  components: {
    ObModal,
    ExpertModalContent,
  },
  props: {
    data: {
      type: Object,
      default: () => ({}),
    },
    departureUuid: String,
    arrivalUuid: String,
    resourceUuid: String,
  },
  data() {
    return {
      approved: false,
      hasChanges: false,
      hasInitialPrice: false,
      introduced: null,
      tariffUuid: null,

      initRateData: {
        distance: 0,
        priceKm: 0,
        priceStage: 0,
      },
      rateData: {
        distance: 0,
        priceKm: 0,
        priceStage: 0,
      },
    };
  },
  computed: {
    distance() {
      return this.data.distance;
    },
    priceType() {
      if (this.hasInitialPrice) {
        if (this.approved) {
          return PRICE_TYPE.EXPERT;
        } else {
          return PRICE_TYPE.EXTRAPOLATED;
        }
      } else {
        return PRICE_TYPE.EMPTY;
      }
    },
    confirmText() {
      if (this.priceType === PRICE_TYPE.EXTRAPOLATED) {
        return this.hasChanges ? 'Сохранить' : 'Подтвердить';
      }
      return 'Сохранить';
    },
    submitDisabled() {
      if (this.priceType === PRICE_TYPE.EXTRAPOLATED) {
        return false;
      }

      return (
        !this.hasChanges || !this.rateData.priceKm || !this.rateData.distance
      );
    },
    priceStage() {
      if (!this.hasChanges) {
        return this.rateData.priceStage;
      }

      return this.rateData.distance * this.rateData.priceKm;
    },
  },
  methods: {
    async open() {
      let response;
      this.expertPrice = null;

      try {
        if(this.data.uuid){
          response = await api.base_prices.getExpertPrice(
            this.departureUuid,
            this.arrivalUuid,
            this.resourceUuid
          );
        } else {
          throw {}
        }
      } catch (e) {
        response = {
          approved: false,
          distance: '',
          introduced_at: '',
          price_km: '',
          price_stage: '',
          tariff_uuid: null,
          uuid: null,
        };
      } finally {
        this.approved = response.approved;
        this.hasInitialPrice = !!response.price_km;
        this.introduced = response.introduced_at;
        this.tariffUuid = response.uuid;

        this.$nextTick(() => {
          this.$refs.expertTarif.open();
        });

        if (!response.distance) {
          const ratePriority = ['expert_price', 'fixed_price', 'base_price'];
          const result = ratePriority
            .map(rateName => ({
              rateName,
              ...this.data[rateName],
            }))
            .find(resourceData => !!(resourceData || {}).distance);

          const { distance } = result || {};

          response.distance = distance
            ? distance
            : await this.getExtrapolateDistance();
        }

        this.rateData = {
          distance: response.distance,
          priceKm: response.price_km,
          priceStage: response.price_stage,
        };

        this.initRateData = {
          ...this.rateData,
          introduced: response.introduced_at,
        };
      }
    },
    async getExtrapolateDistance() {
      try {
        const { distance } = await api.base_prices.getExtrapolationDistance(
          this.departureUuid,
          this.arrivalUuid,
          this.resourceUuid
        );
        return distance;
      } catch {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных',
        });
      }
    },
    async saveExpert() {
      let notificationId = new Date().getTime() + 'save';

      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId,
        });

        await api.base_prices.updateExpertPrice(
          this.departureUuid,
          this.arrivalUuid,
          this.resourceUuid,
          {
            price_stage: this.rateData.priceStage,
            price_km: this.rateData.priceKm,
            distance: this.rateData.distance,
          }
        );

        this.$notification({
          type: 'system_notification_success',
          message: `Сохранено`,
        });


        this.$emit('updated');
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено',
        });
      } finally {
        this.$notification({ event: 'close', id: notificationId });
      }

      this.$refs.expertTarif.close();
    },
    updateStagePrice(newRateData) {
      this.rateData = newRateData;

      if (
        this.initRateData.distance !== this.rateData.distance ||
        this.initRateData.priceKm !== this.rateData.priceKm
      ) {
        this.hasChanges = true;
        this.introduced = new Date();
        return;
      }

      if (
        this.initRateData.distance === this.rateData.distance &&
        this.initRateData.priceKm === this.rateData.priceKm
      ) {
        this.hasChanges = false;
        this.introduced = this.initRateData.introduced;
      }
    },
  },
};
</script>
